using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using System.Configuration;

namespace Benday.TddWithRepository.Business
{
    public class ObjectFactory : IObjectFactory
    {
        private UnityContainer m_container;
        private UnityContainer Container
        {
            get
            {
                if (m_container == null)
                {
                    InitializeContainer("ObjectFactory");
                }
                return m_container;
            }
            set { m_container = value; }
        }

        private void InitializeContainer(string containerConfigName)
        {
            UnityContainer container = new UnityContainer();

            container.RegisterInstance<IObjectFactory>(this);

            UnityConfigurationSection section = (UnityConfigurationSection)ConfigurationManager.GetSection("unity");

            section.Containers[containerConfigName].Configure(container);

            m_container = container;
        }

        public T Create<T>()
        {
            return Container.Resolve<T>();
        }

        public void Reconfigure(string configurationName)
        {
            InitializeContainer(configurationName);
        }
    }
}
