﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;

namespace Benday.TddWithRepository.Business
{
    public class UserDataAccess
    {
        public UserDataAccess()
        {

        }

        private string m_connectionString;
        protected string ConnectionString
        {
            get
            {
                if (m_connectionString == null)
                {
                    m_connectionString = ConfigurationManager.ConnectionStrings["default"].ConnectionString;
                }

                return m_connectionString;
            }
        }

        public User GetByUserName(string username)
        {
            string query = 
                @"SELECT u.Id, u.Username, p.Id as PersonId, p.FirstName, p.LastName 
                FROM 
                UserLogin u 
                JOIN
                Person p
                ON u.PersonId = p.Id
                where u.UserName = @username";

            DataTable table = new DataTable();

            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                conn.Open();

                using (SqlCommand cmd = new SqlCommand(query, conn))
                {
                    cmd.Parameters.Add(new SqlParameter("@username", username));

                    using (SqlDataAdapter adapter = new SqlDataAdapter(cmd))
                    {
                        adapter.Fill(table);
                    }
                }                
            }

            if (table.Rows.Count == 0)
            {
                // no match
                return null;
            }
            else
            {
                User user = new User();

                DataRow row = table.Rows[0];

                user.Id = Int32.Parse(row["Id"].ToString());
                user.PersonId = Int32.Parse(row["PersonId"].ToString());
                user.UserName = row["Username"].ToString();
                user.FirstName = row["FirstName"].ToString();
                user.LastName = row["LastName"].ToString();

                return user;
            }
        }
    }
}
