using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TddWithRepository.Business;
using System.Configuration;
using System.Data.SqlClient;

namespace Benday.TddWithRepository.UnitTests
{
    [TestClass]
    public class DatabaseUserRepositoryFixture
    {
        [TestMethod]
        public void GetByUserName()
        {
            DatabaseUserRepository repository = new DatabaseUserRepository();

            string expectedUsername = "benday";

            User user = repository.GetByUserName(expectedUsername);

            Assert.IsNotNull(user, "Should have gotten a user.");

            Assert.AreEqual<string>(expectedUsername, 
                user.UserName, 
                "Repository retrieved a user with the wrong Username.");

            Assert.AreEqual<string>("Ben", user.FirstName, "FirstName was wrong.");
            Assert.AreEqual<string>("Day", user.LastName, "LastName was wrong.");            
        }

        private string m_connectionString;
        protected string ConnectionString
        {
            get
            {
                if (m_connectionString == null)
                {
                    m_connectionString = ConfigurationManager.ConnectionStrings["default"].ConnectionString;
                }

                return m_connectionString;
            }
        }

        [TestInitialize]
        public void SetupTest()
        {
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                using (SqlCommand command = new SqlCommand())
                {
                    command.Connection = conn;

                    command.CommandType = System.Data.CommandType.StoredProcedure;
                    command.CommandText = "SetupDatabaseForDataUserRepositoryFixture";

                    conn.Open();

                    command.ExecuteNonQuery();
                }
            }
        }
    }
}
