using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TddWithRepository.Business;
using System.Configuration;
using System.Data.SqlClient;

namespace Benday.TddWithRepository.UnitTests
{
    public class RepositoryMock<T> : IRepository<T> where T : IInt32Id
    {
        private int m_currentIdValue = 0;

        public RepositoryMock()
        {
            Items = new List<T>();
        }

        protected List<T> Items { get; set; }

        public void Save(T saveThis)
        {
            if (saveThis == null)
            {
                throw new ArgumentNullException("saveThis", "Argument cannot be null.");
            }

            if (saveThis.Id == 0)
            {
                saveThis.Id = ++m_currentIdValue;
            }

            if (Items.Contains(saveThis) == false)
            {
                Items.Add(saveThis);
            }
        }

        public T GetById(int id)
        {
            return (from item in Items
                    where item.Id == id
                    select item).FirstOrDefault();
        }

        public IList<T> GetAll()
        {
            return Items;
        }

        public void Delete(T saveThis)
        {
            Items.Remove(saveThis);
        }
    }
}
