﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TddWithRepository.Business;
using System.Configuration;
using System.Data.SqlClient;

namespace Benday.TddWithRepository.UnitTests
{

    [TestClass]
    public class UserFacadeFixture
    {
        [TestMethod]
        public void UsernameExists()
        {
            UserFacade facade = new UserFacade();

            string userNameThatShouldExist = "benday";
            string usernameThatShouldNotExist = "benday2";

            Assert.IsTrue(
                facade.UsernameExists(userNameThatShouldExist),
                "User name should exist.");

            Assert.IsFalse(
                facade.UsernameExists(usernameThatShouldNotExist),
                "User name should not exist.");
        }

        private string m_connectionString;
        protected string ConnectionString
        {
            get
            {
                if (m_connectionString == null)
                {
                    m_connectionString = ConfigurationManager.ConnectionStrings["default"].ConnectionString;
                }

                return m_connectionString;
            }
        }

        [TestInitialize]
        public void SetupTest()
        {
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                using (SqlCommand command = new SqlCommand())
                {
                    command.Connection = conn;

                    command.CommandType = System.Data.CommandType.StoredProcedure;
                    command.CommandText = "SetupDatabaseForUsernameExistsTest";

                    conn.Open();

                    command.ExecuteNonQuery();
                }
            }
        }
    }
}
