using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TddWithRepository.Business;
using System.Configuration;
using System.Data.SqlClient;

namespace Benday.TddWithRepository.UnitTests
{
    [TestClass]
    public class UserFacadeWithRepositoryFixture
    {
        [TestMethod]
        public void UsernameExistsWithRepository()
        {
            UserFacadeWithRepository facade = new UserFacadeWithRepository(m_userRepositoryInstance);

            string userNameThatShouldExist = "benday";
            string usernameThatShouldNotExist = "benday2";

            Assert.IsTrue(
                facade.UsernameExists(userNameThatShouldExist),
                "User name should exist.");

            Assert.IsFalse(
                facade.UsernameExists(usernameThatShouldNotExist),
                "User name should not exist.");
        }

        private IUserRepository m_userRepositoryInstance;

        [TestInitialize]
        public void SetupTest()
        {
            m_userRepositoryInstance = new InMemoryUserRepository();

            // add the "benday" user to the 'database'
            m_userRepositoryInstance.Save(
                new User()
                {
                    UserName = "benday",
                    FirstName = "Ben",
                    LastName = "Day"
                });
        }
    }
}